//Kompilierer
/*

              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
              ~ m o d u l e _ c o m p . h ~
              ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Abstrakte Basisklasse fr Module zur Kompilierung (von Roboterprogrammen).

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.
*/


#ifndef MODULE_COMPH
#define MODULE_COMPH


#include "module.h"



///Eine Basisklasse fr Module zum Kompilieren von Roboterprogrammen, bereits
///spezialisiert darauf, mit variablen Roboterdaten umzugehen.
//classis infinita
struct module_comp :
  public module
{
  public:
   virtual int get_status( void ) = 0;
   virtual char* get_name( void ) = 0;

   //confundet ordinem:
   virtual bool confunde(char*) = 0; ///<Kompiliert einen Quelltext.

   //confundet ordinem principalis (,,fundamen") in loco ,,da_via_fun_c" rescripto:
   virtual bool confunde_fundamen() = 0; ///<Kompiliert das Basisprogramm.

   ///Gibt den Pfad zum kompilierten Basisprogramm zurck.
   ///(lat.: gib_Pfad_zum_kompilierten_Basisprogramm)
   //dat via fundaminis confusi:
   virtual char* da_via_fun_c( void ) = 0;                                                    

  protected:
   //lector datorum:
   module* lector; ///<Dateilesemodul (lat.: Leser)

   ///Transformiert einen Roboter-Programmtext, der in nichtkompilierbarer Form
   ///vorliegt (z. B. in einer vllig abstrakten Programmiersprache, also nicht
   ///NQC, Lejos oder dergleichen). Intern von den ffentlichen Methoden 
   ///aufzurufen.
   ///(lat.: bersetze_Gebenes)
   //transformat litteras fontanas, si necessarium est. Ista functio provocato
   //in functionis publicis.
   virtual bool transscribe_data(char*) = 0;
};



#endif
