///Konfigurationsdateileser
/*

                 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                 ~ m o d u l e _ c o n f . h ~
                 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Abstrakte Basisklasse fr Module zur Verwaltung von Konfigurationsdateien.

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.

*/
  
     
#ifndef MODULE_ROBODATAH
#define MODULE_ROBODATAH
        

#include "module.h"

         

///Objekte dieser Klasse sollen das Umgehen mit Konfigurationsdateien bernehmen.
//classis infinita
struct module_conf :
  public module
{
  public:
   ///Liest ein einfaches Datum aus der Datei aus, das nicht weiter
   ///bersetzt zu werden braucht.
   ///(lat.: gib_Gegebenes)
   //leget et dat datum nominis additi ex datorum:
   virtual char* da_datum(const char*) = 0;
   
   ///Diese Funktion prft, ob ihr Argument eine Variable in der 
   ///Konfigurationsdatei ist.
   ///(lat.: ist_es_ein_Gegebenes)
   //probat, si datum est nominis additi:
   virtual bool estne_datum(const char*) = 0;
};



#endif
