///Module mit Zugriff auf den Linux-NQC-Kompilierer
/*

        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        ~ m o d u l e _ l i n u x n q c . c p p ~
        ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Basisklasse fr Module, welche den Linux-NQC-Kompilierer verwenden.
(http://bricxcc.sourceforge.net/nqc/) Bietet bislang nur eine Methode, welche
Rckgabewerte von nqc-Aufrufen auf Erfolg oder Mierfolg berprfen soll, was
aber bisher nur in sehr beschrnktem Mae verwirklicht ist.

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.

*/


#ifndef MODULE_LINUXNQCCPP
#define MODULE_LINUXNQCCPP


#include "module_linuxnqc.h"



///Prft den Rckgabewert des system(,,nqc")-Aufrufs auf Erfolg oder Mierfolg.
///(Umfassendere Implementierung ist wnschenswert.)
///@param rescriptum_nqc Rckgabewert des zu prfenden nqc-Aufrufs
bool module_linuxnqc::proba_rescriptum_nqc(int rescriptum_nqc)
{
   switch (rescriptum_nqc)
   {
      case -1:
         module_master::ptr().broadcast("*module_comp_linuxnqc: system(,,nqc\") - error");
         return false;
      case 127:
         module_master::ptr().broadcast("#module_comp_linuxnqc: system(,,nqc\") -> execve() - Mglicherweise ist ein Fehler aufgetreten.");
         return true;
      default:
         return true;
   }
}



#endif
