///Module mit Zugriff auf den Linux-NQC-Kompilierer
/*

         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
         ~ m o d u l e _ l i n u x n q c . h ~
         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Basisklasse fr Module, welche den Linux-NQC-Kompilierer verwenden.
(http://bricxcc.sourceforge.net/nqc/) Bietet bislang nur eine Methode, welche
Rckgabewerte von nqc-Aufrufen auf Erfolg oder Mierfolg berprfen soll, was
aber bisher nur in sehr beschrnktem Mae verwirklicht ist.

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.

*/


#ifndef MODULE_LINUXNQCH
#define MODULE_LINUXNQCH


//via confunditoris:
#define VIA_NQC "" //ubique
//nomen datorum fundaminis (rudis et confusi):
#define FUNDAMEN "fundamen"


#include <string>
#include "module.h"
#include "module_conf.h"


using namespace std;



///Externes Instrumentarium fr Modulklassen, die den Linux-NQC-Kompilierer
///benutzen.
//classis infinitissima
struct module_linuxnqc :
  public module
{
  protected:
   bool proba_rescriptum_nqc(int); ///<Behandelt die Rckgabewerte des Linux-NQC-Kompilierers.
};



#endif
