#include "module_log.h"
#include <iostream>
#include <fstream>
#include <time.h>

const int LOG_CACHE_SIZE = 10;
const char* LOG_FILENAME = "eukalyptos.log";

int module_log::handle_msg( const char* msg )
{
    //Die Nachricht wird in cache gespeichert
    //Dort befinden sich die LOG_CACHE_SIZE letzen Nachrichten
    
    int size=cache.size();
    cache.push(msg);

    //Eigentlich reichte ein "if..." aus, aber man wei ja nie...
    while (size>LOG_CACHE_SIZE) { cache.pop(); size=cache.size(); }; 
    
    //Die Log-Datei
    if( !log_file.is_open() )
	    log_file.open( LOG_FILENAME, ios::app );

    //Der vorangestellte Buchstabe legt den Nachrichtentyp fest
    //Falls keines der spezifizierten damit bereinstimmt, wird vom
    //Typ "Information" ausgegangen
    char* type="";
    switch(*msg)
        {
        case '*': { type="FEHLER: "; ++msg; break;} 
        case '#': { type="Warnung: "; ++msg; break;} 
        case '!': { type=""; ++msg; break;}          
        }
        
    //Die aktuelle Nachricht wird nebst Zeitstempel in die Log-Datei geschrieben:
    char buffer[40] = { 0 };

    time_t now;
    tm* now_local;
    
    now = time( NULL );
    now_local = localtime( &now );

    strftime( buffer, 40, "%d.%m.%Y %H:%M:%S", now_local );
    log_file << "[" << buffer << "] " << type << msg << endl;

    if (log_file) 
    { return( 0 ); }
    else
    { return( -1); }
}

///Markiert den Anfang einer Sitzung in der Log-Datei.
int module_log::mod_load( void )
{
    module_master::ptr().broadcast( "!-------- ANFANG DER SITZUNG --------" );
    return( 0 );
}

///Markiert das Ende einer Sitzung in der Log-Datei.
///Beachte: Im Falle eines Absturzes entfllt dieser Eintrag.
int module_log::mod_unload( void )
{
    module_master::ptr().broadcast( "!--------- ENDE DER SITZUNG ---------" );
    return( 0 );
}
