/// module_log.h
///
/// Modul zum Speichern und Bereithalten von (Fehler-)Meldungen

#ifndef MODULE_LOG_H
#define MODULE_LOG_H

#include "module.h"
#include <queue>
#include <list>
#include <fstream>

using namespace std;

class module_log : public module
{
    public:
		
	int get_status( void )
	{
		return( 0 );
	}
	
	///Speichert die eingehenden Meldungen in eine Datei ab
    ///und hlt sie fr die Anzeige durch die GUI bereit.
    	int handle_msg( const char* msg );
	
	int mod_load( void );

	int mod_unload( void );  
	
    /// Identifiziert den Typ des Moduls.
	char* get_name( void )
	{
		return( "module_log" );
	}                        

    ///Gibt die Anzahl der Nachrichten im privaten Zwischenspeicher zurck
    int get_msg_number( void )
    {
        return cache.size();
    }
	
	///Gibt die lteste im Zwischenspeicher befindliche Nachricht zurck
	///und lscht sie aus diesem.
	string get_oldest_msg( void )
	{
        	string tmp;
		if( !cache.empty() )
		{
			tmp = cache.front();
			tmp.erase( 0, 1 );	// erstes Zeichen, das den Typ angibt, entfernen.
        		cache.pop();
		}
        	return tmp;
    }
    
	private:
           
	ofstream log_file;    
    	queue<string> cache; ///< Zwischenspeicher fr die letzten eingegangenen Nachrichten
};

#endif
 
