/// module_parser.h
/// 
/// Modul zum Parsen von Quelltexten.

#ifndef MODULE_PARSER
#define MODULE_PARSER

#include <vector>
#include "module.h"
#include "module_conf_ConfigFile.h"
#include "module_map.h"
#include "protocol.h"

class module_parser : public module
{
	public:

		// Geerbte Methoden
		
		int mod_load( void );
		int mod_unload( void );
		int handle_msg( const char* msg );
	
		/// Identifiziert den Typ des Moduls.
		virtual char* get_name( void )
		{
			return( "module_parser" );
		}

		int get_status( void );

		// Eigene Methoden
		
        vector<saved_net_msg> parse(string input);

	private:
	
		module_conf* mod_conf;
		module_map* mod_map;

		unsigned char MSG_CODE;
};

#endif
 
