///Roboterkommunikation
/*

           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
           ~ m o d u l e _ r o b o c o m . h ~
           ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Schnittstellenbasisklasse fr Module zur Steuerung des Datenverkehrs
mit dem Roboter.

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.

*/


#ifndef MODULE_ROBOCOMH
#define MODULE_ROBOCOMH


#include "module.h"



///Objekte dieser Klasse sind fr Steuerung des und Kommunikation mit dem 
///Roboter zustndig.
//classis infinita
struct module_robocom :
  public module
{
  public:
   virtual int get_status( void ) = 0;
   virtual char* get_name( void ) = 0;
   
   virtual bool anima() = 0;	///<Initialisiert den Roboter.
   virtual bool inanima() = 0;  ///<Schaltet den Roboter ab.
   virtual bool reanima() = 0;  ///<Reaktiviert den Roboter.
	
   virtual bool mitte_iussum(char*) = 0;  ///<Sendet einen Befehl.
  
   ///Ping
   virtual int ping() = 0;
  
   ///Empfangene Information (in Form eines Feldes) zurckgeben/Informationen
   ///zuvor empfangen
   virtual void* accipe_nuntios() = 0;
};



#endif                              
