///Roboterkommunikation via Linux-nqc
/*

     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     ~ m o d u l e _ r o b o c o m _ l i n u x n q c . c p p ~
     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Eine Modulklasse zur Roboterkommunikation, welche die Konsolenfunktionen des 
NQC-Kompilierers fr Linuxsysteme nutzt. (http://bricxcc.sourceforge.net/nqc/)
Funktioniert nur zusammen mit einem Kompiliermodul des Typs 
module_comp_linuxnqc, mit dem sie auch die Basisklasse module_linuxnqc teilt.

Alle Konstrukte tragen lateinische Bezeichnungen. Latein ist neben Englisch
womglich die einzige Weltsprache, die sich korrekt mit den ersten 128 ASCII-
Zeichen schreiben lt.

Dieser Quelltext ist ursprnglich Teil des Programmes Eukalyptos, welches zur
Netzwerkfernsteuerung von Lego-RCX-2-Robotern dient und von Lutz Bch, Bastian
Rieck und Carlos Franke im Rahmen eines Praktikums am Interdisziplinren 
Zentrum fr Wissenschaftliches Rechnen (IWR) der Universitt Heidelberg 
geschaffen wurde.

*/


#ifndef MODULE_ROBOCOM_LINUXNQCCPP
#define MODULE_ROBOCOM_LINUXNQCCPP


#define PATRIA "./"
#define NQC_TEMP "./nqc-Ausgabe.temp"
#define VESTIFICULUS "./Ihr_Programm"
#define NUMERATOR_HORREI "./Speicherplatztest"
#define RENOVATOR_HORREI "./Speicherplatzerschaffung"


#include <iostream>
#include "module_robocom_linuxnqc.h"



///Konstruktor:
module_robocom_linuxnqc::module_robocom_linuxnqc()
{
   exflumen_lit.flush();
   influmen_lit.str("");
   influmen_lit.clear();
   via_nqc = VIA_NQC;
   status = 0;
}


///Die beiden whrend des Modulladevorgangs kompilierten Programme sind fr die 
///Funktion permuta_horreum gedacht, welche jedoch nicht fertig implementiert
///worden ist und nun auch ohne jene auskommen wrde.
int module_robocom_linuxnqc::mod_load()
{
   //Zuknftig zu erledigen: Ist nqc da? Ist der Roboter da? Fehlerbehandlung!
   confunditor = module_master::ptr().get_module("module_comp_linuxnqc", -1);
   lector = module_master::ptr().get_module("module_conf", -1);
   influmen_lit.str(((module_conf*)lector)->da_datum("HAUPTSPEICHERPLATZ"));
   influmen_lit >> horreum_principale;
   
   turris = (string)(((module_conf*)lector)->da_datum("SENDER"));

    
   //NUMERATOR_HORREI  
   flumen_dat.close();
   flumen_dat.clear();
   flumen_dat.open(((string)NUMERATOR_HORREI + (string)".nqc").c_str(), ios_base::out|ios_base::trunc);
   if(!flumen_dat)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Fehler beim Oeffnen der Datei "
                                    + (string)NUMERATOR_HORREI + (string)".nqc . "
                                    + (string)"Schneiderleinbefehle werden wahrscheinlich nicht richtig funktionieren.").c_str());
      status = -1;
      return -1;
   }
   flumen_dat <<   (string)  " task main()                 \n"
                 + (string)  " {                           \n"
                 + (string)  "    AddToDatalog(Program()); \n"
                 + (string)  " }                           \n";
   flumen_dat.close();
   flumen_dat.flush();
   flumen_dat.clear();  
   
   bool estne_verum = ((reinterpret_cast<module_comp*>(confunditor))->confunde((char*)(((string)NUMERATOR_HORREI + (string)".nqc").c_str())));
   
   if(!estne_verum)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Fehler beim Vorbereiten des Programms "
                                    + (string)NUMERATOR_HORREI + (string)".rcx. "
                                    + (string)"Schneiderleinbefehle werden wahrscheinlich nicht richtig funktionieren.").c_str());
      status = -1;
      return -1;
   }
   
   
   //RENOVATOR_HORREI
   flumen_dat.close();
   flumen_dat.clear();
   flumen_dat.open(((string)RENOVATOR_HORREI + (string)".nqc").c_str(), ios_base::out|ios_base::trunc);
   if(!flumen_dat)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Fehler beim ffnen der Datei "
                                    + (string)RENOVATOR_HORREI + (string)".nqc . "
                                    + (string)"Schneiderleinbefehle werden wahrscheinlich nicht richtig funktionieren.").c_str());
      status = -1;
      return -1;
   }
   flumen_dat <<   (string)  " task main()                 \n"
                 + (string)  " {                           \n"
                 + (string)  "    CreateDatalog(10);       \n"
                 + (string)  " }                           \n";
   flumen_dat.close();
   flumen_dat.flush();
   flumen_dat.clear();  
   
   estne_verum = ((reinterpret_cast<module_comp*>(confunditor))->confunde((char*)(((string)RENOVATOR_HORREI + (string)".nqc").c_str())));
   
   if(!estne_verum)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Fehler beim Vorbereiten des Programms "
                                    + (string)RENOVATOR_HORREI + (string)".rcx. "
                                    + (string)"Schneiderleinbefehle werden wahrscheinlich nicht richtig funktionieren.").c_str());
      status = -1;
      return -1;
   }
   
   status = 1;
   return 0;
}


int module_robocom_linuxnqc::mod_unload()
{
   //Nihil reliqueris nisi mortuum!
   if(!inanima())
   {
      module_master::ptr().broadcast("#module_robocom_linuxnqc: Fehler beim Abschalten des Roboters.");
      return -1;
   }
   status = 0;
   return 0;
}


int module_robocom_linuxnqc::handle_msg(const char* nuntius)
{
   //nihil faciendum est.
   return 0;
}


int module_robocom_linuxnqc::get_status()
{
   return status;
}


char* module_robocom_linuxnqc::get_name()
{
   return "module_robocom_linuxnqc";
}


///Initialisiert den Roboter.
///@param b Strohpuppenparameter; dient nur dazu, da die andere Fassung von \
///         anima Richtig aufgerufen werden kann.
bool module_robocom_linuxnqc::anima()
{
   float b;
   return anima(b);
}

///Initialisiert den Roboter.
///@param B In diese Variable (wohlgemerkt: referenziell bergeben) wird die
///aktuelle Batteriespannung des Roboters geschrieben.
bool module_robocom_linuxnqc::anima(float& B)
{
   //Zu erledigen: NQC-Meldungen behandeln. (Roboter nicht erreichbar z. B.)

   if(!(reinterpret_cast<module_comp_linuxnqc*>(confunditor))->confunde_fundamen(B)) //transitus classium necessarius est.
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Die Kompilierung des Roboterprogramms ist gescheitert.").c_str());
      return false;
   }

   int rescriptum = system((via_nqc + (string)"nqc " + turris
                                    + (string)" -far").c_str());
   if(! proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name() 
                                    + (string)": Die Reichweite des IR-Turms konnte nicht gesetzt werden.").c_str());
   }
   
   sleep(1);

   rescriptum = system((via_nqc + (string)"nqc " + turris
                                    + (string)" -sleep 66").c_str());
   if(! proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name() 
                                    + (string)": Die Wach-Wartezeit des Roboters konnte nicht auf 66 Minuten gesetzt werden. Er wird sich mglicherweise zu frh automatisch abschalten.").c_str());
   }

   sleep(1);
   
   //mitte iussum permutationis horrei ad horreum_principale:
   if(!(permuta_horreum((string)(((module_conf*)lector)->da_datum("HAUPTSPEICHERPLATZ")), true)))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": anima(): Der Wechsel zum Hauptprogrammspeicherplatzes konnte nicht erfolgen.").c_str());
      return false;                              
   }   
   
   sleep(1);

   //mitte praeceptum:
   rescriptum = system((via_nqc + (string)"nqc -d " + turris + (string)" "
                        + (string)(((module_comp*)confunditor)->da_via_fun_c())
                        + (string)FUNDAMEN + (string)".temp.rcx").c_str());
   if(! proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"*" + get_name() 
                                    + (string)": Fehler bei der Programmbertragung zum Roboter.").c_str());
      return false;
   }
   
   sleep(2);

   //incipe praeceptum:
   rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -run").c_str());
   return proba_rescriptum_nqc(rescriptum);
}


///Schaltet den Roboter ab.
bool module_robocom_linuxnqc::inanima()
{
   //Zu erledigen: Testen, ob dieser Befehl den Roboter wirklich abschaltet.
   int rescriptum = system((via_nqc + (string)"nqc " + turris
                          + (string)" -sleep 1").c_str());
   if(!proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                    + (string)": Fehler beim Setzen der Schlafzeit des Roboters. Er wird mglicherweise nicht richtig abgeschaltet.").c_str());
   }
   
   rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -msg "
                      + (string)(((module_conf*)lector)->da_datum("ABBRUCH"))).c_str());
   
   return proba_rescriptum_nqc(rescriptum);
}


///Schaltet den Roboter an, ohne ihn von grundauf zu initialisieren.
bool module_robocom_linuxnqc::reanima()
{
   int rescriptum = system((via_nqc + (string)"nqc " + turris
                                    + (string)" -far").c_str());
   if(! proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name() 
                                    + (string)": Die Reichweite des IR-Turms konnte nicht gesetzt werden.").c_str());
   }
   
   sleep(1); 
   
   //mitte iussum permutationis horrei ad horreum_principale:
   if(!permuta_horreum((string)(((module_conf*)lector)->da_datum("HAUPTSPEICHERPLATZ")), true ))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": reanima(): Der Wechsel zum Hauptprogrammspeicherplatz konnte nicht erfolgen.").c_str());
      return false;                              
   } 
   
   sleep(1);  
   
   rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -run").c_str());
   return proba_rescriptum_nqc(rescriptum);
}


///Sendet einen einzelnen Befehl an den Roboter.
bool module_robocom_linuxnqc::mitte_iussum(char* iussum)
{
   return mitte_iussum((string)iussum);
}

bool module_robocom_linuxnqc::mitte_iussum(string iussum)
{
   string temp = ((module_conf*)lector)->da_datum(iussum.c_str());
   if(temp == "")
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                    + (string)": Der Befehl ,," + iussum
                                    + (string)"''ist unbekannt.").c_str());
      return false;
   }

   cout << (string)"nqc " + turris + (string)" -msg " + temp + '\n';
   
   return proba_rescriptum_nqc(
             system(((string)"nqc " + turris + (string)" -msg " + temp).c_str()));
}


///Sendet ein Signal an den Roboter - ohne in der Konfigurationsdatei zu prfen,
///ob es wirklich einen Befehl kodiert.
bool module_robocom_linuxnqc::mitte_iussum(int iussum)
{
   exflumen_lit.str("");
   exflumen_lit.flush();
   exflumen_lit.clear(); 

   exflumen_lit << iussum;
   if(iussum < 0 || iussum > 255)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": Der Befehlcode" + exflumen_lit.str()
                                    + (string)" ist ungltig. (Muss zwischen 0 und 255 liegen.)").c_str());
   }

   cout << via_nqc + (string)"nqc " + turris + (string) " -msg "
                          + exflumen_lit.str() + '\n';
   
   int rescriptum = system((via_nqc + (string)"nqc " + turris + (string) " -msg "
                          + exflumen_lit.str()).c_str());

   exflumen_lit.str("");
   exflumen_lit.flush();
   exflumen_lit.clear();   
   return proba_rescriptum_nqc(rescriptum);
}


///Sendet einen Schneiderleinbefehl. Damit der Roboter wieder in den Grundzustand wechselt,
///musz reanima() aufgerufen werden. Im Normalfall (wenn das nutzerdefinierte Programm funk-
///tioniert) sollte dies geschehen, sobald AUSFUEHRUNGSPROTOKOLL_ENDE im Datalog (mit
///accipe_nuntios() auszulesen) steht.
bool module_robocom_linuxnqc::mitte_ordinem(char* ordo)
{
   return mitte_ordinem((string)ordo);
}

///@param locus Markiert Stellen in Zeichenketten, je nach Bedarf in der Funktion.
///@param num_unc Zhler fr geschweifte Klammern im vom Nutzer eingegebenen Quelltext.
///@param ordo der Nutzerquelltext alias Schneiderleinbefehl
bool module_robocom_linuxnqc::mitte_ordinem(string ordo)
{
   string::size_type locus = 0;
   int num_unc = 0;  //numerus uncorum
   string::size_type temp = 0;  //numerus temporarius
   
   locus = ordo.find("task main()");
   if(!proba_npos(locus, "task main()"))
      return false;
      
   locus = ordo.find("{", locus);
   if(!proba_npos(locus, "{"))
      return false;
   ++num_unc;
   
   ordo.insert(locus+1,  (string)"\n   until(Message() == " 
                       + (string)((reinterpret_cast<module_conf*>(lector))->da_datum("START_PHASE_2"))  + (string)");\n\n");
   
   while(num_unc > 0)
   {
      locus = ordo.find_first_of("{}", locus+1);
      if(!proba_npos(locus, "{\" oder ,,}"))
         return false;
         
      if(ordo[locus] == '{')
      {
        ++num_unc; 
      }
      else if(ordo[locus] == '}')
      {
         --num_unc;
      }  
      else
      {
         module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                       + (string)": mitte_ordinem: Fataler Fehler bei der Quelltexttransformation.").c_str());
         return false;
      }
   }
   
   if(num_unc < 0)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Fataler Fehler bei der Quelltexttransformation.").c_str());            
      return false;
   }
 
   ordo.insert(locus,  (string)"\n\n   AddToDatalog("
                     + (string)(((module_conf*)lector)->da_datum("AUSFUEHRUNGSPROTOKOLL_ENDE"))                     
                     + (string)");\n");
                
   flumen_dat.open(((string)VESTIFICULUS + (string)".nqc").c_str(), ios_base::out|ios_base::trunc);
   flumen_dat << ordo;
   flumen_dat.flush();
   flumen_dat.close();
   flumen_dat.clear();
   
  { 
   bool estne_verum = ((reinterpret_cast<module_comp*>(confunditor))->confunde((char*)((string)VESTIFICULUS + (string)".nqc").c_str()));
   if(! estne_verum)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Fehler bei der Quelltextkompilierung.").c_str());      
      return false;                                    
   }
  }
   
    
   int rescriptum;
   
   if(!permuta_horreum((string)(((module_conf*)lector)->da_datum("FREISPEICHERPLATZ"))))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Der Wechsel des Roboterprogrammspeicherplatzes konnte nicht erfolgen.").c_str());
      return false;                              
   }   
   
   rescriptum = system((via_nqc + (string)"nqc " + turris
                          + (string)" -d " + (string)VESTIFICULUS + (string)".rcx").c_str());
   if(!proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Fehler beim Programmversand.").c_str());      
      return false;
   }    
   
   
   if(!permuta_horreum((string)(((module_conf*)lector)->da_datum("HAUPTSPEICHERPLATZ"))))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Der Wechsel zurck zum Hauptprogramm ist gescheitert. Der Roboter sollte reanimiert werden!").c_str());
      return false;                              
   } 
   
         
   return true;
}



///Lt den gespeicherten Schneiderleinbefehl ausfhren, ohne diesen noch einmal
///zu berprfen.
///@return Erfolg/Mierfolg
bool module_robocom_linuxnqc::obsequere_ordini()
{
   if(!permuta_horreum((string)(((module_conf*)lector)->da_datum("FREISPEICHERPLATZ"))))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": obsequere_ordini: Der Wechsel zurck zum Hauptprogramm ist gescheitert. Der Roboter sollte reanimiert werden!").c_str());
      return false;                              
   } 
   
   
   sleep(1);
   
   int rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -run ").c_str());
   cout << (via_nqc + (string)"nqc " + turris + (string)" -run ");
   if(!proba_rescriptum_nqc(rescriptum))
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                    + (string)": mitte_ordinem: Fehler beim Roboterprogrammstart.").c_str());      
      return false;
   }
   
   rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -msg" + (string)((reinterpret_cast<module_conf*>(lector))->da_datum("START_PHASE_2"))).c_str());
   
   cout << (via_nqc + (string)"nqc " + turris + (string)" -msg " + (string)((reinterpret_cast<module_conf*>(lector))->da_datum("START_PHASE_2")));
   
   return proba_rescriptum_nqc(rescriptum);
}


///Hilfsfunktion, um string-Suchoperationen etwas uebersichtlicher zu machen
///@param s Die Zeichenkette, nach der gesucht wurde
///@return falsch, falls i gleich string::npos, sonst wahr
bool module_robocom_linuxnqc::proba_npos(string::size_type i, char* s)
{
   if(i == string::npos)
   {
      module_master::ptr().broadcast(((string)"#" + (string)get_name() + (string)": ,," 
                                    + (string)s + "\" wurde nicht im Quelltext gefunden.").c_str());
      return false;
   }
   
   return true;
}


///Hilfsfunktion zur Steuerung des Wechsels des Roboterprogrammspeicherplatzes
///Vorsicht: 
///Die Funktion ist leider nicht so implementiert, wie sie werden sollte. 
///Damit der Teil unter ,,hic sunt dracones" richtig funktioniere, mssen
///nicht nur sie, sondern auch smtliche NQC-Programme, die im Laufe dieses
///g a n z e n  (C++-)Programms auf den Roboter geladen werden, mehr oder 
///minder berarbeitet werden. Ohne umfassende nderungen wrden sonst alle
///Programme gelscht, bevor sie ausgefhrt werden knnten.
///@param numerus_horrei Nummer des angestrebten Programmspeicherplatzes in einer Zeichenkette
///@param renovatio Falls dieser Wert wahr ist, wird der alte Datalog des Roboters geloescht. \
///                 Ansonsten musz im alten noch mindestens eine Stelle frei sein. Unbedingt! (Wird derzeit nicht benutzt.)
///@return Erfolg/Miszerfolg
bool module_robocom_linuxnqc::permuta_horreum(string numerus_horrei, bool renovatio)
{
   system( ("nqc -Susb -pgm " + numerus_horrei).c_str() );
   return( true );


   /*
   	hic sunt dracones
   */


   string libellus = "";
   int rescriptum;      

   #define NUM_REP 13
   //numerus repetitionum

   for(short i = 1; i <= NUM_REP; i++)
   {
      rescriptum = system((via_nqc + (string)"nqc " + turris 
                             + (string)" -pgm " 
                             + numerus_horrei).c_str());
      if(!proba_rescriptum_nqc(rescriptum))
      {
         module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                       + (string)": Fehler beim Roboterprogrammspeicherplatzwechsel.").c_str());      
         ++i;
         continue;
      }
      
      sleep(1);
      
      if(renovatio)
      {
         cout << "Renovatio;\n";
         cout.flush();
         rescriptum = system((via_nqc + (string)"nqc " + turris
                            + (string)" -d " + (string)RENOVATOR_HORREI + (string)".rcx").c_str());
         if(!proba_rescriptum_nqc(rescriptum))
         {
            module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                          + (string)": Fehler beim Speicherplatzschaffungsprogrammversand.").c_str());      
            ++i;
            continue;
         } 
         
         sleep(1);     
      
         rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -run").c_str());
         if(!proba_rescriptum_nqc(rescriptum))
         {
            module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                          + (string)": Fehler beim Speicherplatzschaffungsprogrammstart.").c_str());      
            ++i;
            continue;
         }
         
         sleep(1); 
      }
           
      cout << "*** VERSENDE PRUEFPROGRAMM AUF AKTUELLEN SPEICHERPLATZ ***" << "\n\n";
      rescriptum = system((via_nqc + (string)"nqc " + turris
                         + (string)" -d " + (string)NUMERATOR_HORREI + (string)".rcx").c_str());
      if(!proba_rescriptum_nqc(rescriptum))
      {
         module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                       + (string)": Fehler beim Pruefprogrammversand.").c_str());      
         ++i;
         continue;
      }   
      
      sleep(1);     
      
      rescriptum = system((via_nqc + (string)"nqc " + turris + (string)" -run").c_str());
      if(!proba_rescriptum_nqc(rescriptum))
      {
         module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                       + (string)": Schwierigkeiten beim Roboterprogrammspeicherplatzwechsel.").c_str());      
         ++i;
         continue;
      }
      
      sleep(1);
      
      libellus = accipe_nuntios();
      
      cout << "Datalog: " << libellus << "\'\n";
   
         
      string::size_type temp1 = libellus.length();
      if(temp1 <= 1)
      {
         module_master::ptr().broadcast(((string)"#" + (string)get_name()
                                       + (string)": Widrigkeiten beim Roboterprogrammspeicherplatzwechsel.").c_str());      
         ++i;
         continue;
      }
      
      string::size_type temp2 = libellus.find_last_of("\n", libellus.find_last_of("\n")-1);//temp1-2/*0, temp1-1?*/);
      if(temp2 == string::npos)
      {
         module_master::ptr().broadcast(((string)"!" + (string)get_name()
                                       + (string)": Seltsamkeit beim Roboterprogrammspeicherplatzwechsel: Das Datenlogbuch des Roboters ist beinahe leer.").c_str());      
         temp2 = 0;
      }
      
      cout << temp1 << '\n';
      cout << temp2 << '\n';
      cout << "So wird der Datalog ausgewertet: " << atoi(libellus.substr(temp2/*+1, temp1-temp2-2*/).c_str()) << '\n';
          
      if(atoi(libellus.substr(temp2/*+1, temp1-temp2-2*/).c_str()) == atoi(numerus_horrei/*_minor*/.c_str()))
      {
         cout << "*** PERMUTA_HORREUM: Programmspeicherplatz gewechselt auf " 
	      << libellus.substr( temp2 ) 
	      << " == "
	      << numerus_horrei << "\n\n";
	 break;   // v i c t o r i a !
      }
      else
      {
         exflumen_lit.flush();
         exflumen_lit.str("");
         exflumen_lit.clear();
         exflumen_lit << i;
         module_master::ptr().broadcast(((string)"#Der Wechsel des Roboterprogrammspeicherplatzes ist "
                                       + exflumen_lit.str() + (string)" mal gescheitert.").c_str());
         exflumen_lit.clear();
         exflumen_lit.flush();
         exflumen_lit.str("");
         if(i == NUM_REP)
         {
            module_master::ptr().broadcast(((string)"*Der Wechsel des Roboterprogrammspeicherplatzes ist gescheitert.").c_str());
            return false;                              
         }                             
      }       
   }
   
   #undef NUM_REP
   
   return true;
}


int module_robocom_linuxnqc::ping()
{
   //Zuknftig zu erledigen.
   module_master::ptr().broadcast(((string)"*" + (string)get_name()
                                  + (string)": Die Funktion ,,ping\" ist nicht implementiert.").c_str()); 
   return -1;
}


string module_robocom_linuxnqc::accipe_nuntios(bool)
{
   int rescriptum = system((via_nqc + (string)"nqc " + turris 
                          + (string)" -datalog > " + (string)NQC_TEMP).c_str());

   flumen_dat.open(NQC_TEMP, ios_base::in);
   if(!flumen_dat)
   {
      module_master::ptr().broadcast(((string)"*" + (string)get_name() 
                                    + (string)", Funktion accipe_nuntios: Die Datei " 
                                    + (string)NQC_TEMP 
                                    + (string)" konnte nicht geoeffnet werden.").c_str());
      return "";
   }
                             
   string temp = "";
   while(!flumen_dat.eof())
   {
      temp += flumen_dat.get();
   }
   
   
   flumen_dat.close();
   flumen_dat.clear();
   
   return temp;
}

char* module_robocom_linuxnqc::accipe_nuntios()
{
   return (char*)(accipe_nuntios(true)).c_str();
}



#undef PATRIA
#undef NQC_TEMP
#undef VESTIFICULUS
#undef NUMERATOR_HORREI
#undef RENOVATOR_HORREI


#endif
