#ifndef SIM_LANGUAGE_H
#define SIM_LANGUAGE_H

#include <string>
#include <vector>

using namespace std;

/// Konstanten, die den Quelltext lesbarer machen sollen
/// Typenkonstanten:
const int NUMBER = 0;
const int VARIABLE = 1;
const int TERM = 2;
/// Operatorkonstanten
const int POW = 0;
const int DIV = 1;
const int MULT = 2;
const int SUBT = 3;
const int ADD = 4;

/// Ein Term mit einem Infix-Rechenzeichen (Operator) und zwei Operanden,
/// je nach Situation knnen dies Zahlen, Variablen (p_0, p_1, p_2,...)
/// oder wiederum Terme sein. Mit dieser Art der Verschachtelung kann man
/// beliebig komplizierte Formeln ausdrcken.
class term
{
	public:
		unsigned long evaluate( vector<unsigned char> params );
      double precisely_evaluate( vector<double> params );
      string strip();

		short atype;  ///< Der Typ des linken Operanden
		short btype;
		long avalue;  ///< Enthlt den Wert des linken Operanden, falls eine Zahl, den Index, falls eine Variable
		long bvalue;
		vector<term> aterm;  ///< Enthlt einen Term, falls der linke Operand ein Term ist
		vector<term> bterm;
		short op;  ///< Die Nummer des Operators
};

/// Enthlt einen Elementarbefehl (Vorwrts, links, ...) und seinen Parameter.
/// Dieser ist in Form eines Terms gespeichert, da er noch von Variablen abhngen kann.
struct conf_command
{
       string name;
       term formula;
};

vector<conf_command> term_parse_cmd(string input);
string term_set_parenthesis(string input);
vector<term> term_terminate(string input);

#endif
